unit Unit1;
{
  Delphi-7
  help file editor version 6
  31 lines per page.
  maximal 1000 lines.
  120 characters per line.
  commands:
  \@name;  point to location
  \#name;  location identifier
  \c       courier font
  \f       fat
  \h       header
  \i       italic
  \l       large
  \m       background color
  \n       normal
  \p       superscript (power)
  \s       subscript
  \t       tab, next 100 horizontal pixel multiple
  \[       box mode start/end

  keyboard commands
  <ctrl> X    erase line
         Y    shift lines UP
         Z    shift lines DOWN
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, ToolWin, ComCtrls, StdCtrls, ExtCtrls, Menus;

type
  Tform1 = class(TForm)
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    helpbox: TPaintBox;
    SpeedButton1: TSpeedButton;
    openBtn: TSpeedButton;
    saveBtn: TSpeedButton;
    pageBar: TScrollBar;
    msgtext: TStaticText;
    clearBtn: TSpeedButton;
    linkBtn: TSpeedButton;
    codebox: TPaintBox;
    linetext: TStaticText;
    helpBtn: TSpeedButton;
    procedure helpboxPaint(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure openBtnClick(Sender: TObject);
    procedure saveBtnClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure pageBarChange(Sender: TObject);
    procedure clearBtnClick(Sender: TObject);
    procedure linkBtnClick(Sender: TObject);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure codeboxPaint(Sender: TObject);
    procedure codeboxClick(Sender: TObject);
    procedure helpboxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure helpboxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure helpBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  form1: Tform1;

implementation

{$R *.DFM}

uses helpunit;

type TLinklist = record
                  s  : string;
                  px1 : smallInt;   //x position
                  px2 : smallInt;
                  L1  : smallInt;   //first line
                  L2  : smallInt;   //second line
                 end;
     TScanmode = (smRead,smControl,smSkip,smReal);

const maxcolumn = 120;
      maxline = 1000;
      linesperpage = 31;
      lineheight = 25;
    //==  maxpage = 25;      //1..25
    //==  maxLine = linesperpage*maxpage;
      maxtopline = maxline - linesperpage;
      standardfont = 'arial';
      standardheight = 20;
      largeheight = 25;
      smallheight = 15;
      standardcolor = $000000;
      altcolor = $00a000;
      headercolor = $0000ff;
      standardbrush = $f0ffff;
      altbrush = $d8d8d8;
      standardstyles = [];
      maxaltchars = 3; //'e'  'i'   'o' alternatieven
      altchars : array[1..maxaltchars] of string =
                 ('E' + #235 + #234 + #233 + #232,
                  'I' + #239,
                  'O' + #242 + #243 + #244 + #245 + #246);
      controlchar = '\';
      topmarge = 5;
      leftmarge = 5;
      maxlink = 50;

var textBuf : array[1..maxcolumn,1..maxline] of char;
    lineNr : smallInt;   //line of cursor
    colNr : byte;        //column of cursor
    topline : smallInt;  //line at top of page
    bm : Tbitmap;
    altindex : byte = 0;
    realmode : boolean = true;
    linklist : array[1..maxlink] of TLinklist;
    linkcount : byte;
    cursrect : Trect;
    cursOn   : boolean;
    arrow    : Tbitmap;
    dot      : Tbitmap;
    scanmode : Tscanmode;
    oldx     : word;
    lineActive : boolean;
    linkline : smallInt;

function getcharwidth(c : char) : byte;
//supply width of c
begin
 result := trunc(bm.Canvas.textwidth(c)*1.1)+1;
end;

function buf2string(nr : smallInt) : string;
var i : byte;
begin
 i := 1;
 result:= '';
 while (i <= maxcolumn) and (textbuf[i,nr] <> #0) do
  begin
   result := result + textbuf[i,nr];
   inc(i);
  end;
end;

procedure string2buf(const s:string; nr:smallInt);
//buffer must be cleared before
var i,n : byte;
begin
 n := length(s);
 if n > maxcolumn then n := maxcolumn;
 for i := 1 to n do textbuf[i,nr] := s[i];
end;

function getTextLength(nr : smallInt) : byte;
//supply length of line, #0 ends string
var i : byte;
begin
 i := 1;
 while (i <= maxcolumn) and (textbuf[i,nr] <> #0) do inc(i);
 result := i-1;
end;

function getLineRect : Trect;
var nr : smallInt;
begin
 nr := lineNr - topline;
 with result do
  begin
   Left := 0;
   Right := bm.Width;
   Top := nr * lineheight + topmarge;
   Bottom := Top + lineheight;
  end;
end;

procedure erasePage;
begin
 with bm do
  with canvas do
   begin
    brush.Style := bsSolid;
    brush.color := standardbrush;
    fillrect(rect(0,0,width,height));
   end;
end;

procedure eraseLine;
var r : Trect;
begin
 r := getLineRect;
 with bm do with canvas do
  begin
   brush.color := standardbrush;
   brush.Style := bsSolid;
   fillrect(r);
  end;
end;

procedure showline;
var r : Trect;
begin
 r := getLineRect;
 form1.helpbox.canvas.copyrect(r,bm.Canvas,r);
end;

procedure showpage;
begin
 form1.helpbox.canvas.draw(0,0,bm);
end;

procedure bmNormal;
begin
 with bm.canvas do
  begin
   pen.color := standardcolor;
   brush.color := standardbrush;
   brush.style := bsClear;
   font.name := 'arial';
   font.color := standardcolor;
   font.style := [];
   font.height := standardheight;
  end;
end;

procedure CursorOff;
begin
 if cursOn then
  begin
   form1.helpbox.canvas.copyrect(cursrect,bm.Canvas,cursrect);
   cursOn := false;
  end;
end;

function NextCursorPos(x:word; cc:char) : word;
//x : current x position
//cc: character
//use scanmode var & update
begin
 result := x;
 with bm.Canvas do
  begin
   case scanmode of
     smRead    : if cc = controlchar then scanmode := smControl
                  else result := result + getcharwidth(cc);
     smControl : begin
                  scanmode := smRead;
                  case upcase(cc) of
                   'C' : font.Name := 'courier new';
                   'L' : font.height := largeheight;
                   'S' : font.height := smallheight;
                   'P' : font.height := smallheight;
                   'N' : begin
                          font.name := standardfont;
                          font.height := standardheight;
                          font.style := [];
                         end;
                   'F' : font.style := [fsbold];
                   'M' : ;
                   'T' : result := ((result div 100)+1)*100;
                   '[' : inc(result,10);
                   'I' : font.Style := [fsItalic];
                   'H' : font.Height := 25;
                   '@' : begin
                          inc(result,arrow.width);
                          scanmode := smSkip;
                         end;
                    '#' : begin
                           inc(result,dot.width);
                           scanmode := smSkip;
                          end;
                  end;//case
                 end;
       smSkip :  case cc of
                  ';', ' '    : scanmode := smRead;
                  controlchar : scanmode := smControl;
                 end;
       smReal : result := result + getcharwidth(cc);
    end;//case
  end;
end;

function getCursorPos(c: byte; lnr : smallInt) : smallInt;
//calculate cursor position of char c at line nr
var i : byte;
   cc : char;
begin
 BMnormal;
 result := leftmarge;
 if realmode then scanmode := smReal else scanmode := smRead;
 if getTextlength(lnr) > 0 then
  with bm.Canvas do
  for i := 1 to c-1 do
   begin
    cc := textBuf[i,lnr];
    result := NextCursorPos(result,cc);
{====
    case scanmode of
     smRead    : if cc = controlchar then scanmode := smControl
                  else result := result + getcharwidth(cc);
     smControl : begin
                  scanmode := smRead;
                  case upcase(cc) of
                   'C' : font.Name := 'courier new';
                   'L' : font.height := largeheight;
                   'S' : font.height := smallheight;
                   'P' : font.height := smallheight;
                   'N' : begin
                          font.name := standardfont;
                          font.height := standardheight;
                          font.style := [];
                         end;
                   'F' : font.style := [fsbold];
                   'M' : ;
                   'T' : result := ((result div 100)+1)*100;
                   '[' : inc(result,10);
                   'I' : font.Style := [fsItalic];
                   'H' : font.Height := 25;
                   '@' : begin
                          inc(result,arrow.width);
                          scanmode := smSkip;
                         end;
                    '#' : begin
                           inc(result,dot.width);
                           scanmode := smSkip;
                          end;
                  end;//case
                 end;
       smSkip :  case cc of
                  ';', ' '    : scanmode := smRead;
                  controlchar : scanmode := smControl;
                 end;
       smReal : result := result + getcharwidth(cc);
    end;//case   ===}
   end;//for
end;

procedure cursorOn;
//write cursor at  colNr, lineNr
var px : smallInt;
begin
 px := getcursorPos(colNr,lineNr);
 with cursrect do
  begin
   Top := topmarge+(lineNr-topline)*lineheight;
   Bottom := Top + lineheight;
   Left := px-1;
   Right := px+1;
  end;
 with form1.helpbox do
  with canvas do
   begin
    pen.width := 2;
    pen.color := clred;
    moveto(px,cursrect.top);
    lineto(px,cursrect.bottom-1);
   end;
 cursOn := true;
end;

procedure linemode(t : byte; var x,y : word);
//t=1: vertikaal  t=2: horizontaal t=0: end
var i : byte;
   y1 : smallInt;
begin
 y1 := y + lineheight - 1;
 with bm.Canvas do
  begin
   pen.color := $707070;
   pen.Width := 1;
   case t of
    0 : lineActive := false;
    1 : begin
         inc(x,5);
         if lineActive = false then
          begin
           lineActive := true;
           oldx := x;
           for i := 0 to 1 do
            begin
             moveto(x+i,y+3); lineto(x+i,y+lineheight);
            end;
          end
         else             //line active
          begin
           lineActive := false;
           for i := 0 to 1 do
            begin
             moveto(oldx,y+1+i); lineto(x,y+1+i);
             moveto(oldx,y1-i); lineto(x,y1-i);
             moveto(x+i,y+1); lineto(x+i,y+lineheight);
            end;
          end;//else
         inc(x,5);
        end; //1
    2 : if lineactive then
         begin
          for i := 0 to 1 do
           begin
            moveto(oldx,y+1+i); lineto(x,y+1+i);
            moveto(oldx,y1-i); lineto(x,y1-i);
           end;
          oldx := x;
         end;
   end;//case
 end;//with
end;

procedure paintline(nr : smallInt);
//paint & update regel nr
var      i : byte;
     px,py : word;
        cc : char;
        dy : integer;
begin
 dy := 5;
 px := leftmarge;
 py := (nr-topline)*lineheight+topmarge;
 linemode(0,px,py); //switch off
 bmNormal;
 if realmode then scanmode := smReal else scanmode := smRead;
 with bm.canvas do
  for i := 1 to getTextlength(nr) do
   begin
    cc := textBuf[i,nr];
    case scanmode of
     smRead    : if cc = controlchar then scanmode := smControl
                  else
                   begin
                    textout(px,py+dy,cc);
                    px := px + getcharwidth(cc);
                    linemode(2,px,py);                   //continue
                   end;
     smControl : begin
                  scanmode := smRead;
                  case upcase(cc) of
                   'C' : font.Name := 'courier new';
                   'L' : begin
                          font.height := largeheight;
                          dy := 0;
                         end;
                    'S' : begin
                           font.height := smallheight;
                           dy := 12;
                          end;
                    'P' : begin
                           font.height := smallheight;
                           dy := 0;
                          end;
                    'N' : begin
                           font.name := standardfont;
                           font.color := clBlack;
                           font.height := standardheight;
                           font.style := [];
                           brush.color := standardbrush;
                           font.Color := $0;
                           dy := 5;
                           linemode(0,px,py);//uitschakelen
                          end;
                    'F' : font.style := font.Style + [fsbold];
                    'M' : begin
                           brush.Style := bsSolid;
                           brush.color := altbrush;
                          end;
                    'T' : px := ((px div 100)+1)*100;
                    '[' : linemode(1,px,py);    //init
                    'I' : begin
                           font.Style := font.Style + [fsItalic];
                           font.color := clBlue;
                          end;
                    'H' : begin
                           font.Color := $0000a0;
                           font.Height := 25;
                           dy := 0;
                          end;
                    '@' : begin
                           draw(px,py,arrow);
                           inc(px,arrow.width);
                           scanmode := smSkip;
                          end;
                    '#' : begin
                           draw(px,py,dot);
                           inc(px,dot.width);
                           scanmode := smSkip;
                          end;
                  end;//case
                 end;
       smSkip :  case cc of
                  ';', ' '    : scanmode := smRead;
                  controlchar : scanmode := smControl;
                 end;
       smReal : begin
                 textout(px,py+dy,cc);
                 px := px + getcharwidth(cc);
                end;
    end;//case
   end;//for
end;

procedure paintpage;
var i : smallInt;
begin
 for i := topline to topline + linesperpage - 1 do
  if gettextlength(i) <> 0 then paintline(i);
end;

procedure refreshpage;
begin
 cursOn := false;
 erasepage;
 paintpage;
 showpage;
 cursorOn;
end;

procedure refreshline;
begin
 cursOn := false;
 eraseline;
 paintline(lineNr);
 showline;
 cursorOn;
end;

procedure GotoLine(lnr : smallInt);
//called by links
begin
 linkline := 0;
 cursorOff;
 topline := lnr;
 lineNr := topline;
 colNr := 1;
 form1.pagebar.position := topline-1;
 refreshpage;
end;

function y2line(y : integer) : smallInt;
var n : smallInt;
begin
 result := topline + ((y-5) div lineheight);
 n := topline + linesperpage -1;
 if result > n then result := n;
end;

{-----initializing-----}

procedure cleartextbuffer;
var i,j : word;
begin
 for j := 1 to maxline do
  for i := 1 to maxcolumn do textbuf[i,j] := #0;
end;

procedure clearlinklist;
var i : byte;
begin
 linkcount := 0;
 for i := 1 to maxlink do
  with linklist[i] do
   begin
    s := '';
    px1 := 0;
    px2 := 0;
    L1 := 0;
    L2 := 0;
   end;
end;

procedure createArrow;
var i : byte;
begin
 arrow := Tbitmap.Create;
 with arrow do with canvas do
  begin
   width := 20;
   height := 25;
   pixelformat := pf32bit;
   brush.style := bsSolid;
   brush.color := $ffffff;
   fillrect(rect(0,0,width,height));
   pen.color := $ff0000;
   pen.Width := 1;
   for i := 5 to 12 do
    begin
     moveto(5,i); lineto(15,i);
    end;
   for i := 0 to 7 do
    begin
     moveto(2+i,i+13); lineto(18-i,i+13);
    end;
   transparentcolor := $ffffff;
   transparent := true;
  end;
end;

procedure createDot;
begin
 dot := TBitmap.Create;
 with dot do with canvas do
  begin
   width := 20;
   height := 25;
   pixelformat := pf32bit;
   brush.color := $ffffff;
   brush.Style := bsSolid;
   fillrect(rect(0,0,width,height));
   pen.color := $ff0000;
   brush.color := $ff0000;
   ellipse(5,8,15,18);
   transparent := true;
   transparentcolor := $ffffff;
  end;
end;

procedure initialize;
begin
 lineActive := false;
 oldX := leftmarge;
 realmode := false;
 topline := 1;    //line at top of page
 lineNr := 1;
 colNr := 1;
 cursOn :=false;
 linkline := 0;
 form1.pagebar.max := maxtopline-1; //starts at 0, not 1
 form1.pagebar.Position := 0;
 cleartextbuffer;
 clearlinklist;
end;

procedure Tform1.FormCreate(Sender: TObject);
begin
 initialize;
 createArrow;
 createDot;
 bm := Tbitmap.create;
  with bm do
   begin
    height := helpbox.height;
    width := helpbox.width;
    pixelformat := pf32bit;
   end;
 refreshpage;  
end;

procedure Tform1.FormDestroy(Sender: TObject);
begin
 bm.free;
 bm := nil;
 arrow.Free;
 arrow := nil;
 dot.Free;
 dot := nil;
end;

{-------- editing ----------}

procedure inschar(c : byte; ch : char);
//insert ch at column c
var i : byte;
begin
 if getTextlength(lineNr) < maxcolumn then
  begin
   cursOn := false;
   for i := maxcolumn downto c+1 do textbuf[i,lineNr] := textbuf[i-1,lineNr];
   textbuf[c,lineNr] := ch;
   inc(colNr);
   refreshline;
  end; 
end;

procedure delChar(c : byte);
//delete column c in line lineNr
var i : byte;
begin
 for i := c to maxcolumn-1 do textbuf[i,lineNr] := textbuf[i+1,lineNr];
 textbuf[maxColumn,lineNr] := #0;
end;

procedure delproc;
begin
 if gettextlength(lineNr) > 0 then
  begin
   delChar(colNr);
   refreshline;
  end;
end;

procedure backspaceProc;
//called if colNr > 1
begin
 if (getTextlength(lineNr) > 0) and (colNr > 1) then
  begin
   cursorOff;
   delChar(colNr-1);
   dec(colNr);
   refreshline;
  end;
end;

procedure enterProc;
begin
 cursorOff;
 if lineNr < maxline then inc(lineNr);
 colNr := 1;
 if lineNr >= topline+linesperpage then
  begin
   inc(topline);
   form1.pageBar.Position := topline-1;
   refreshpage;
  end
 else cursorOn;
end;

procedure endProc;
begin
 cursorOff;
 colNr := gettextlength(lineNr)+1;
 cursorOn;
end;

procedure homeProc;
begin
 cursorOff;
 colNr := 1;
 cursorOn;
end;

procedure leftproc;
begin
 cursorOff;
 if colNr > 1 then dec(colNr);
 cursorOn;
end;

procedure upproc;
var n : byte;
begin
 if lineNr > 1 then
  begin
   cursorOff;
   dec(lineNr);
   if lineNr < topline then
    begin
     dec(topline);
     form1.pageBar.position := topline-1;
     refreshpage;
    end
    else
     begin
      n := gettextlength(lineNr);
      if colNr > n then colNr := n+1;
      cursorOn;
     end;
  end;
end;

procedure rightproc;
begin
 cursorOff;
 if colNr <= gettextlength(lineNr) then inc(colNr);
 cursorOn;
end;

procedure downproc;
var n : byte;
begin
 if lineNr < maxline then
 begin
  cursorOff;
  inc(lineNr);
  if lineNr >= topline+linesperpage then
   begin
    inc(topline);
    form1.pageBar.position := topline-1;
    refreshpage;
   end
  else
   begin
    n := getTextlength(LineNr);
    if colNr > n then colNr := n+1;
    cursorOn;
   end;
 end;
end;

procedure deleteline(nr : smallInt);
var i : byte;
begin
 for i := 1 to maxcolumn do textbuf[i,nr] := #0;
 colNr := 1;
 refreshline;
end;

procedure shiftUp;
var j : word;
    i : byte;
begin
 cursOn := false;
 for j := lineNr to maxline-1 do
  for i := 1 to maxcolumn do textbuf[i,j] := textBuf[i,j+1];
 for i := 1 to maxcolumn do textbuf[i,maxline] := #0;
 refreshpage;
end;

procedure shiftdown;
var j : word;
    i : byte;
begin
 cursOn :=false;
 for j := maxline downto lineNr+1 do
  for i := 1 to maxcolumn do textbuf[i,j] := textBuf[i,j-1];
 for i := 1 to maxcolumn do textbuf[i,lineNr] := #0;
 refreshpage;
end;

procedure adjustCursor;
//called after topline modification
var n : byte;
begin
 if lineNr < topline then lineNr := topline;
 if lineNr >= topline+linesperpage then lineNr := topline+linesperpage-1;
 n := getTextLength(lineNr);
 if colNr > n then colNr := n+1;
end;

procedure scrollUp;
begin
 if topline > 1 then
  begin
   cursorOff;
   dec(topline);
   form1.pageBar.position := topline - 1;
   adjustcursor;
   refreshpage;
  end; 
end;

procedure scrollDown;
begin
 if lineNr < maxtopline then
  begin
   cursorOff;
   inc(topline);
   form1.pageBar.Position := topline-1;
   adjustcursor;
   refreshpage;
  end;
end;

function linkpos(var lnr : byte; name : string) : boolean;
//get first line nr of link
begin
 lnr := 1;
 result := false;
 while (result=false) and (lnr <= maxlink) do
  if name = linklist[lnr].s then result := true
   else inc(lnr);
end;

procedure makelinklist;
var i,n,k : byte;
        j : smallInt;
       cc : char;
        m : Tscanmode;
     orgF : boolean;
       id : string;
       OK : boolean;
begin
 orgF := false;
 n := 0;
 for j := 1 to maxline do
  begin
   m := smRead;
   for i := 1 to gettextlength(j) do
    begin
     cc := textbuf[i,j];
     case m of
      smRead    : if cc = controlchar then m := smControl;
      smControl : case cc of
                   '@' : begin
                          m := smSkip;
                          orgF := true;
                          id := '';
                         end;
                   '#' : begin
                          m := smSkip;
                          orgF := false;
                          id := '';
                         end;
                   else m := smRead;
                  end;
      smSkip    : case cc of
                   controlchar : m := smRead;
                           ';' : begin
                                  m := smRead;
                                  if (n < maxlink) and (length(id) > 0) then
                                   if orgF then
                                    begin
                                     inc(n);
                                     linklist[n].s := id;
                                     linklist[n].L1 := j;
                                     linklist[n].px1 := getCursorPos(i,j)-arrow.width;
                                    end
                                    else
                                     if linkpos(k,id) then
                                      begin
                                       linklist[k].L2 := j;
                                       linklist[k].px2 := getcursorpos(i,j)-dot.Width;
                                      end;
                                 end;
                   else id := id + cc;
                  end;
     end;//case
    end;//i
  end;//j
 with form1.msgtext do
  if n = 0 then caption := 'no links found'
   else caption := 'links found = '+ inttostr(n);
 linkcount := n;
 OK := linkcount > 0;
 i := 0;
 while OK and (i < linkcount) do
  begin
   inc(i);
   with linklist[i] do
    begin
     if L1 = L2 then begin
                      OK := false;
                      form1.msgtext.caption := 'line '+ inttostr(L1)+
                      ' points to itself';
                     end;
      if L2 = 0 then begin
                      OK := false;
                      form1.msgtext.caption := 'line '+ inttostr(L1)+
                      ' points to nothing';
                     end;
    end;
  end;//while
 OK := linkcount > 1;
 i := 0;
 while OK and (i < linkcount-1) do
  begin
   inc(i);
   k := i;
   while OK and (k < linkcount) do
    begin
     inc(k);
     OK := linklist[i].s <> linklist[k].s;
     if OK = false then form1.msgtext.Caption := 'duplicate link names';
    end;
  end;
end;

//--- keyboard events ---

procedure Tform1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var i : byte;
begin
 if key = 18 then     //alt key pressed
  begin
   altindex := 0;
   exit;
  end;
  if shift = [] then
   begin
    case key of
             35 : endProc;
             36 : homeProc;
             37 : leftproc;
             38 : upproc;
             39 : rightproc;
             40 : downproc;
             46 : delproc;
    end; //case
   end;

 if (shift * [ssALT] = [ssALT]) and (key < 256) then
 begin
  for i := 1 to maxaltchars do
   begin
    if char(key) = altchars[i][1] then
     begin
      if altindex = 0 then
       begin
        altindex := 2;
        insChar(colNr,altchars[i][altindex]);
       end
       else
        begin
         inc(altindex);
         if altindex > length(altchars[i]) then altindex := 2;
         textbuf[colNr-1,lineNr] := altchars[i][altindex];
         refreshline;
        end;
     end;
   end; //for i
 end;
 
 if shift = [ssCTRL] then
  begin
   case key of
             ord('X') : deleteline(lineNr);
             ord('Y') : shiftUp;
             ord('Z') : shiftdown;
   end;//case
  end;
end;

procedure Tform1.FormKeyPress(Sender: TObject; var Key: Char);
begin
 case key of
   #8  : backspaceproc;
   #13 : enterproc;
   else if (ord(key) >= 32) then insChar(colNr,key);
  end;//case
end;

//--- clicks ---

procedure Tform1.SpeedButton1Click(Sender: TObject);
//show page 1
begin
 topline := 1;
 lineNr := 1;
 colNr := 1;
 pagebar.Position := 0;
 refreshpage;
end;

procedure Tform1.openBtnClick(Sender: TObject);
var    w : word;
  infile : textfile;
       s : string;
      OK : boolean;
begin
 w := 0;
 OK := false;
 with form1.OpenDialog1 do
  begin
   if execute then
    try
     cleartextbuffer;
     assignfile(infile,filename);
     reset(infile);
     w := 0;
     while not Eof(inFile) do
      begin
       inc(w);
       readln(infile,s);
       string2buf(s,w);
      end;
     OK := true;
    finally
     closefile(infile);
     topline := 1;
     colNr := 1;
     lineNr := 1;
     if OK then
      begin
       makelinklist;
       refreshpage;
       msgtext.caption := 'file loaded. Lines = '+inttostr(w);
      end
      else msgtext.Caption := 'cannot read file';
    end;//execute
  end;//with
end;

procedure Tform1.saveBtnClick(Sender: TObject);
var w       : word;
    size    : word;
    outfile : textfile;
    s       : string;
    OK      : boolean;
begin
//bepaal de lengte van de tekst
 size := 0;
 OK := false;
 for w := 1 to maxline do if gettextlength(w) > 0 then size := w;
 if size = 0 then exit;

 with form1.SaveDialog1 do
  if execute then
   try
    assignfile(outfile,filename);
    rewrite(outfile);
    for w := 1 to size do
     begin
      s := buf2string(w);
      writeln(outfile,s);
     end;
    OK := true;
   finally
    closefile(outfile);
    If OK then msgtext.Caption := 'file saved. Lines = '+inttostr(size)
     else msgtext.Caption := 'cannot write file';
   end;
end;

procedure Tform1.pageBarChange(Sender: TObject);
begin
 topline := pageBar.Position+1;
 adjustcursor;
 refreshpage;
end;

procedure Tform1.clearBtnClick(Sender: TObject);
begin
 initialize;
 refreshpage;
end;

procedure Tform1.linkBtnClick(Sender: TObject);
//make link list
begin
 clearlinklist;
 makelinklist;
end;

procedure Tform1.FormMouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
var x,y : smallInt;
begin
 x := form1.Left + helpbox.Left;
 y := form1.Top + helpbox.Top;
 if (mousepos.X > x+10) and (mousepos.X < x + helpbox.Width-10) and
    (mousepos.Y > y+10) and (mousepos.Y < y + helpbox.Height-10) then
  begin
   if wheeldelta < 0 then scrollDown else scrollUP;
  end;
end;

procedure Tform1.codeboxClick(Sender: TObject);
begin
 realmode := not realmode;
 codebox.Invalidate;
 refreshpage;
end;

//--- paints ---

procedure Tform1.FormPaint(Sender: TObject);
var x1,y1,x2,y2 : word;
    i : byte;
begin
 with helpbox do
  begin
   x1 := left-2;
   x2 := left + width+1;
   y1 := top-2;
   y2 := top + height+1;
  end;
 with canvas do
  for i := 0 to 1 do
   begin
    pen.Color := $000000;
    moveto(x2-i,y1+i);
    lineto(x1+i,y1+i);
    lineto(x1+i,y2-i);
    pen.color := $a0a0a0;
    lineto(x2-i,y2-i);
    lineto(x2-i,y1+i);
   end;
end;

procedure Tform1.codeboxPaint(Sender: TObject);
var i : word;
begin
 with codebox do with canvas do
  begin
   font.Name := 'arial';
   font.height := 25;
   brush.color := $c0ffff;
   fillrect(rect(0,0,width,height));
   for i := 0 to 1 do
    begin
     if realmode then pen.color := $0 else pen.Color := $c0c0c0;
     moveto(width-1-i,i);
     lineto(i,i);
     lineto(i,height-1-i);
     if realmode then pen.color := $ffffff else pen.Color := $c0c0c0;
     lineto(width-1-i,height-1-i);
     lineto(width-1-i,i);
    end;
   if realmode then font.Color := $0000ff else font.Color := $e0e0ff;
   textout(10,5,'SOURCE CODE');
  end;
end;

procedure Tform1.helpboxPaint(Sender: TObject);
begin
 cursOn := false;
 showpage;
 cursorOn;
end;

//--- mouse ---

procedure Tform1.helpboxMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var line : smallInt;
       i : byte;
 newlink : smallInt;
begin
 line := y2line(y);
 linetext.Caption := inttostr(line);
 i := 0;
 newlink := 0;
 while (newlink = 0) and (i < maxlink) do
  begin
   inc(i);
   with linklist[i] do
    if (line=L1) and (x>px1) and (x<px1+arrow.width) then newlink := L2
     else if (line=L2) and (x>px2) and (x<px2+dot.width) then newlink := 1;
  end;
 if newlink <> linkline then
  begin
   if newlink = 0 then helpbox.cursor := crArrow
    else helpbox.cursor := crHandpoint;
   linkline := newlink;
  end
end;

procedure Tform1.helpboxMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var xx : smallInt;
    oldn,n,n1,n2 : byte;
begin
 if linkline > 0 then
  begin
   GotoLine(linkline);
   helpbox.Cursor := crArrow;
   exit;
  end;

 LineNr := y2line(y);
 colNr := 1;
 oldn := 0;
 n := 1;
 n1 := 1;
 n2 := gettextlength(LineNr) + 1;
 while n <> oldn do
  begin
   oldn := n;
   n := (n1 + n2) shr 1;
   xx := getcursorpos(n, lineNr);
   if xx <= x then n1 := n;
   if xx >= x then n2 := n;
  end;
 colNr := n;
 cursorOff;
 cursorOn;
end;

procedure Tform1.helpBtnClick(Sender: TObject);
begin
 OpenHelp(form1);
end;

end.
